/**********************************************************************************
W5500ģ 

**********************************************************************************/

#include "stm32f10x.h"
#include "spi.h"				
#include "W5500.h"
#include "delay.h"	


// 
u8 Gateway_IP[4];//IPַ 
u8 Sub_Mask[4];	// 
u8 Phy_Addr[6];	//ַ(MAC) 
u8 IP_Addr[4];	//IPַ 

u8 S0_Port[2];	//˿0Ķ˿ں(5000) 
u8 S0_DIP[4];	//˿0ĿIPַ 
u8 S0_DPort[2];	//˿0ĿĶ˿ں(6000) 





u8 UDP_DIPR[4];	    //UDP(㲥)ģʽ,ĿIPַ
u8 UDP_DPORT[2];	//UDP(㲥)ģʽ,Ŀ˿ں


//˿ڵģʽ
u8 S0_Mode =3;	            //˿0ģʽ,0:TCPģʽ,1:TCPͻģʽ,2:UDP(㲥)ģʽ
u8 S1_Mode =3;
#define TCP_SERVER	0x00	//TCPģʽ
#define TCP_CLIENT	0x01	//TCPͻģʽ 
#define UDP_MODE	0x02	//UDP(㲥)ģʽ 

//˿ڵ״̬
u8 S0_State =0;	            //˿0״̬¼,1:˿ɳʼ,2˿() 
u8 S1_State =0;	
#define S_INIT		0x01	//˿ɳʼ 
#define S_CONN		0x02	//˿, 

//˿շݵ״̬
u8 S0_Data;	               	//˿0պͷݵ״̬,1:˿ڽյ,2:˿ڷ 
u8 S1_Data;	 
#define S_RECEIVE	 0x01	//˿ڽյһݰ 
#define S_TRANSMITOK 0x02	//˿ڷһݰ 

//˿ݻ 
u8 Rx_Buffer[2048];	//˿ڽݻ 
u8 Tx_Buffer[2048];	//˿ڷݻ 

u8 W5500_Interrupt;	//W5500жϱ־(0:ж,1:ж)







//W5500˿ڳʼжģʽ
//Ӧ˵
//sck PA5  miso PA6  mosi PA7  rst PA2  int PA3  cs PA0
void W5500_GPIO_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;	

 	EXTI_InitTypeDef EXTI_InitStructure;			//ж	  ĸж  EXTI_Line0-15
													//ģʽ EXTI_Mode_Interruptж  EXTI_Mode_Event ¼
													//ʽ  EXTI_Trigger_Falling ½ش
													//			EXTI_Trigger_Rising	 ش
													//			EXTI_Trigger_Rising_Falling	  ƽ

 	NVIC_InitTypeDef NVIC_InitStructure;			//жϲ жȼ


  	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);	//ʹܸùʱ



	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOA, ENABLE );//PORTBʱʹ 


	// W5500_RSTųʼ(PA2) 
	GPIO_InitStructure.GPIO_Pin  = W5500_RST;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(W5500_RST_GPIO, &GPIO_InitStructure);
	GPIO_ResetBits(W5500_RST_GPIO, W5500_RST);
	
	// W5500_INTųʼ(PA3) 	
	GPIO_InitStructure.GPIO_Pin = W5500_INT;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(W5500_INT_GPIO, &GPIO_InitStructure);


	// ʼģSPI-CS (PA0)
	GPIO_InitStructure.GPIO_Pin = W5500_SCS;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_Init(W5500_SCS_GPIO, &GPIO_InitStructure);
	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);



 	// Enable the EXTI3 Interrupt 
	NVIC_InitStructure.NVIC_IRQChannel = EXTI3_IRQn;				//W5500_INTڵⲿжͨ
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x02;	//ռȼ2 
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x02;			//ȼ2
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;					//ʹⲿжͨ
	NVIC_Init(&NVIC_InitStructure);


  	// Connect EXTI Line3 to PA3 
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource3);


	// PA3 as W5500 interrupt input 
	EXTI_InitStructure.EXTI_Line = EXTI_Line3;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);

}


//ж3  PA3Ӧ W5500 һ־λ
void EXTI3_IRQHandler(void)
{
	if(EXTI_GetITStatus(EXTI_Line3) != RESET)
	{
		EXTI_ClearITPendingBit(EXTI_Line3);	//ж
		W5500_Interrupt=1;
	}
}



//ͨSPI1һֽ
//dat ͵ֽ
//޷
void SPI1_Send_Byte(u8 dat)
{
	SPI_I2S_SendData(SPI1,dat);//д1ֽ
	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);//ѭȴݼĴ
}



//PI12ֽ(16λ)
//dat:͵16λ
void SPI1_Send_Short(u16 dat)
{
	SPI1_Send_Byte(dat/256);//дݸλ   ൱dat>>8
	SPI1_Send_Byte(dat);	//дݵλ
}




//ͨSPI1W5500ַָĴд1ֽ
// reg:16λĴַ,dat:д
void Write_W5500_1Byte(u16 reg, u8 dat)
{
	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CSƬѡW5500

	SPI1_Send_Short(reg);   //ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_WRITE|COMMON_R); //ͨSPI1дֽ,1ֽݳ,д,ѡͨüĴ
	SPI1_Send_Byte(dat);  //д1ֽ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ
}




//ͨSPI1ַָĴд2ֽ
//reg:16λĴַ,dat:16λд(2ֽ)
void Write_W5500_2Byte(u16 reg, u16 dat)
{
	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CSƬѡW5500
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_WRITE|COMMON_R);//ͨSPI1дֽ,2ֽݳ,д,ѡͨüĴ
	SPI1_Send_Short(dat);//д16λ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ
}




//ͨSPI1ַָĴдnֽ
//reg:16λĴַ,*dat_ptr:дݻָ,size:дݳ
void Write_W5500_nByte(u16 reg, u8 *dat_ptr, u16 size)
{
	u16 i;

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CSƬѡW5500	
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(VDM|RWB_WRITE|COMMON_R);//ͨSPI1дֽ,Nֽݳ,д,ѡͨüĴ

	for(i=0;i<size;i++)//ѭsizeֽдW5500
	{
		SPI1_Send_Byte(*dat_ptr++);//дһֽ
	}

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ
}




//ͨSPI1ָ˿ڼĴд1ֽ
//s:˿ں,reg:16λĴַ,dat:д
void Write_W5500_SOCK_1Byte(SOCKET s, u16 reg, u8 dat)
{
	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CSƬѡW5500	
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,1ֽݳ,д,ѡ˿sļĴ
	SPI1_Send_Byte(dat);//д1ֽ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ
}



//ͨSPI1ָ˿ڼĴд2ֽ
//s:˿ں,reg:16λĴַ,dat:16λд(2ֽ)
void Write_W5500_SOCK_2Byte(SOCKET s, u16 reg, u16 dat)
{
	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CSƬѡW5500
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,2ֽݳ,д,ѡ˿sļĴ
	SPI1_Send_Short(dat);//д16λ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ
}




//ͨSPI1ָ˿ڼĴд4ֽ
//s:˿ں,reg:16λĴַ,*dat_ptr:д4ֽڻָ
void Write_W5500_SOCK_4Byte(SOCKET s, u16 reg, u8 *dat_ptr)
{
	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM4|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,4ֽݳ,д,ѡ˿sļĴ

	SPI1_Send_Byte(*dat_ptr++);//д1ֽ
	SPI1_Send_Byte(*dat_ptr++);//д2ֽ
	SPI1_Send_Byte(*dat_ptr++);//д3ֽ
	SPI1_Send_Byte(*dat_ptr++);//д4ֽ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);//CS  ȡƬѡ
}



//ȡW5500ַָĴ1ֽ
//reg:16λĴַ
//:ȡĴ1ֽ
u8 Read_W5500_1Byte(u16 reg)
{
	u8 i;

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500
			
	SPI1_Send_Short(reg);  //ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_READ|COMMON_R);//ͨSPI1дֽ,1ֽݳ,,ѡͨüĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);//Ϳ ȴ
	i=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);//CS  ȡƬѡ
	return i;//ضȡļĴ
}



//W5500ָ˿ڼĴ1ֽ
//s:˿ں,reg:16λĴַ
//ֵ:ȡĴ1ֽ
u8 Read_W5500_SOCK_1Byte(SOCKET s, u16 reg)
{
	u8 i;

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500
			
	SPI1_Send_Short(reg);   //ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_READ|(s*0x20+0x08));//ͨSPI1дֽ,1ֽݳ,,ѡ˿sļĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);   //Ϳ ȴ
	i=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);  //CS  ȡƬѡ
	return i;//ضȡļĴ
}



//W5500ָ˿ڼĴ2ֽ
//s:˿ں,reg:16λĴַ
//ֵ:ȡĴ2ֽ(16λ)
u16 Read_W5500_SOCK_2Byte(SOCKET s, u16 reg)
{
	u16 i;

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_READ|(s*0x20+0x08));//ͨSPI1дֽ,2ֽݳ,,ѡ˿sļĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);//Ϳ ȴ
	i=SPI_I2S_ReceiveData(SPI1);//ȡλ
	SPI1_Send_Byte(0x00);//Ϳ ȴ
	i*=256;
	i+=SPI_I2S_ReceiveData(SPI1);//ȡλ

	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);//CS  ȡƬѡ
	return i;//ضȡļĴ
}




//W5500ݻжȡ
//s:˿ں,*dat_ptr:ݱ滺ָ
//ֵ:ȡݳ,rx_sizeֽ
u16 Read_SOCK_Data_Buffer(SOCKET s, u8 *dat_ptr)
{
	u16 rx_size;
	u16 offset, offset1;
	u16 i;
	u8 j;

	rx_size=Read_W5500_SOCK_2Byte(s,Sn_RX_RSR);
	if(rx_size==0) return 0;  //ûյ򷵻
	if(rx_size>1460) rx_size=1460;

	offset=Read_W5500_SOCK_2Byte(s,Sn_RX_RD);
	offset1=offset;
	offset&=(S_RX_SIZE-1);    //ʵʵַ

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500

	SPI1_Send_Short(offset);//д16λַ
	SPI1_Send_Byte(VDM|RWB_READ|(s*0x20+0x18));//дֽ,Nֽݳ,,ѡ˿sļĴ
	j=SPI_I2S_ReceiveData(SPI1);
	
	if((offset+rx_size)<S_RX_SIZE)//ַδW5500ջĴַ
	{
		for(i=0;i<rx_size;i++)//ѭȡrx_sizeֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
	}
	else//ַW5500ջĴַ
	{
		offset=S_RX_SIZE-offset;
		for(i=0;i<offset;i++)//ѭȡǰoffsetֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
		GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS);  //CS  ȡƬѡ

		GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//CS CSƬѡW5500

		SPI1_Send_Short(0x00);//д16λַ
		SPI1_Send_Byte(VDM|RWB_READ|(s*0x20+0x18));//дֽ,Nֽݳ,,ѡ˿sļĴ
		j=SPI_I2S_ReceiveData(SPI1);

		for(;i<rx_size;i++)//ѭȡrx_size-offsetֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
	}
	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //CS  ȡƬѡ

	offset1+=rx_size;//ʵַ,´ζȡյݵʼַ
	Write_W5500_SOCK_2Byte(s, Sn_RX_RD, offset1);
	Write_W5500_SOCK_1Byte(s, Sn_CR, RECV);//
	return rx_size;//ؽյݵĳ
}



//дW5500ݷͻ
//s:˿ں,*dat_ptr:ݱ滺ָ,size:дݵĳ
void Write_SOCK_Data_Buffer(SOCKET s, u8 *dat_ptr, u16 size)
{
	u16 offset,offset1;
	u16 i;

	//UDPģʽ,ڴĿIPͶ˿ں
	if((Read_W5500_SOCK_1Byte(s,Sn_MR)&0x0f) != SOCK_UDP)//Socketʧ
	{		
		Write_W5500_SOCK_4Byte(s, Sn_DIPR, UDP_DIPR);//ĿIP  		
		Write_W5500_SOCK_2Byte(s, Sn_DPORTR, UDP_DPORT[0]*256+UDP_DPORT[1]);//Ŀ˿ں				
	}

	offset=Read_W5500_SOCK_2Byte(s,Sn_TX_WR);
	offset1=offset;
	offset&=(S_TX_SIZE-1);//ʵʵַ

	GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//W5500SCSΪ͵ƽ

	SPI1_Send_Short(offset);//д16λַ
	SPI1_Send_Byte(VDM|RWB_WRITE|(s*0x20+0x10));//дֽ,Nֽݳ,д,ѡ˿sļĴ

	if((offset+size)<S_TX_SIZE)//ַδW5500ͻĴַ
	{
		for(i=0;i<size;i++)//ѭдsizeֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ		
		}
	}
	else//ַW5500ͻĴַ
	{
		offset=S_TX_SIZE-offset;
		for(i=0;i<offset;i++)//ѭдǰoffsetֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ
		}
		GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //W5500SCSΪߵƽ

		GPIO_ResetBits(W5500_SCS_GPIO, W5500_SCS);//W5500SCSΪ͵ƽ

		SPI1_Send_Short(0x00);//д16λַ
		SPI1_Send_Byte(VDM|RWB_WRITE|(s*0x20+0x10));//дֽ,Nֽݳ,д,ѡ˿sļĴ

		for(;i<size;i++)//ѭдsize-offsetֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ
		}
	}
	GPIO_SetBits(W5500_SCS_GPIO, W5500_SCS); //W5500SCSΪߵƽ

	offset1+=size;//ʵַ,´дݵݻʼַ
	Write_W5500_SOCK_2Byte(s, Sn_TX_WR, offset1);
	Write_W5500_SOCK_1Byte(s, Sn_CR, SEND);//				
}



//W5500Ӳλ
//˵W5500ĸλűֵ͵ƽ500us,ʹW5500븴λ״̬
void W5500_Hardware_Reset(void)
{
	GPIO_ResetBits(W5500_RST_GPIO, W5500_RST);  //λ
	delay_ms(50);
	GPIO_SetBits(W5500_RST_GPIO, W5500_RST);    //λ
	delay_ms(200);
	while((Read_W5500_1Byte(PHYCFGR)&LINK)==0); //ѭȴ̫	Ҫӵ·ɺģ ޷ͨ
}




//ʼW5500ӦĴ
//˵ӲʼҪӦʼ
void W5500_Init(void)
{
	u8 i=0;

	Write_W5500_1Byte(MR, RST);  //λW5500,1Ч,λԶ0
	delay_ms(10);                //ʱ10ms

	//(Gateway)IPַ,Gateway_IPΪ4ֽ
	//ʹؿʹͨͻľޣͨؿԷʵInternet
	Write_W5500_nByte(GAR, Gateway_IP, 4);
			
	//(MASK)ֵ,SUB_MASKΪ4ֽ
	//
	Write_W5500_nByte(SUBR,Sub_Mask,4);		
	
	//ַ,PHY_ADDRΪ6ֽ,Ψһʶ豸ֵַ
	//õֵַҪIEEE룬OUIĹ涨ǰ3ֽΪ̴룬ֽΪƷ
	//ԼַעһֽڱΪż
	Write_W5500_nByte(SHAR,Phy_Addr,6);		

	//ñIPַ,IP_ADDRΪ4ֽ
	//ע⣬IP뱾IPͬһ򱾻޷ҵ
	Write_W5500_nByte(SIPR,IP_Addr,4);		
	
	//÷ͻͽջĴСοW5500ֲ ʼֱΪ2k ܹΪ16k
	for(i=0;i<8;i++)
	{
		Write_W5500_SOCK_1Byte(i,Sn_RXBUF_SIZE, 0x02);//Socket Rx memory size=2k
		Write_W5500_SOCK_1Byte(i,Sn_TXBUF_SIZE, 0x02);//Socket Tx mempry size=2k
	}

	//ʱ䣬ĬΪ2000(200ms) 
	//ÿһλֵΪ100΢,ʼʱֵΪ2000(0x07D0),200
	Write_W5500_2Byte(RTR, 0x07d0);

	//ԴĬΪ8 
	//طĴ趨ֵ,ʱж(صĶ˿жϼĴеSn_IR ʱλ(TIMEOUT)á1)
	Write_W5500_1Byte(RCR,8);

	//жϣοW5500ֲȷԼҪж
	//IMR_CONFLICTIPַͻ쳣ж,IMR_UNREACHUDPͨʱַ޷쳣ж
	//Socket¼жϣҪ
	Write_W5500_1Byte(IMR,IM_IR7 | IM_IR6);	//жĴ
	Write_W5500_1Byte(SIMR,S0_IMR|S1_IMR);			//socketж״̬0-7 ĴS0
	Write_W5500_SOCK_1Byte(0, Sn_IMR, IMR_SENDOK | IMR_TIMEOUT | IMR_RECV | IMR_DISCON | IMR_CON);	//S0 жϹȫ
	Write_W5500_SOCK_1Byte(1, Sn_IMR, IMR_SENDOK | IMR_TIMEOUT | IMR_RECV | IMR_DISCON | IMR_CON);	//S1 жϹȫ
}




////ط
////ģһ˿ڵӦжW5500ģʽǷͨѶ״̬
////ֵ:ɹTRUE(0xFF),ʧܷFALSE(0x00)
//u8 Detect_Gateway(void)
//{
//	u8 ip_adde[4];
//	ip_adde[0]=IP_Addr[0]+1;
//	ip_adde[1]=IP_Addr[1]+1;
//	ip_adde[2]=IP_Addr[2]+1;
//	ip_adde[3]=IP_Addr[3]+1;
//
//	//ؼȡصַ
//	Write_W5500_SOCK_4Byte(0,Sn_DIPR,ip_adde);//ĿĵַĴд뱾IPͬIPֵ
//	Write_W5500_SOCK_1Byte(0,Sn_MR,MR_TCP);   //socketΪTCPģʽ
//	Write_W5500_SOCK_1Byte(0,Sn_CR,OPEN);     //Socket	
//	delay_ms(5);//ʱ5ms 	
//	
//	if(Read_W5500_SOCK_1Byte(0,Sn_SR) != SOCK_INIT)//socketʧ	 TCPģʽʧ
//	{
//		Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//򿪲ɹ,رSocket
//		return FALSE;//FALSE(0x00)
//	}
//
//	Write_W5500_SOCK_1Byte(0,Sn_CR,CONNECT);//SocketΪConnectģʽ	TCPΪͻ					
//
//	do
//	{
//		u8 j=0;
//		j=Read_W5500_SOCK_1Byte(0,Sn_IR);//ȡSocket0жϱ־Ĵ
//		if(j!=0)						 //жʾ д1Ӧж
//		Write_W5500_SOCK_1Byte(0,Sn_IR,j);
//		delay_ms(5);//ʱ5ms 
//		if((j&IR_TIMEOUT) == IR_TIMEOUT) //ʱ
//		{
//			return FALSE;	
//		}
//		else if(Read_W5500_SOCK_1Byte(0,Sn_DHAR) != 0xff)	 //ֻжĩλMAC ǷΪFF ɹӦΪFF
//		{
//			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//رSocket	   ˵Գɹ
//			return TRUE;							
//		}
//	}while(1);
//}


//0-7һ˿ط
//ģһ˿ڵӦжW5500ģʽǷͨѶ״̬
//ֵ:ɹTRUE(0xFF),ʧܷFALSE(0x00)
u8 Detect_Gateway(u8 s)
{
	u8 ip_adde[4];
	ip_adde[0]=IP_Addr[0]+1;
	ip_adde[1]=IP_Addr[1]+1;
	ip_adde[2]=IP_Addr[2]+1;
	ip_adde[3]=IP_Addr[3]+1;

	//ؼȡصַ
	Write_W5500_SOCK_4Byte(s,Sn_DIPR,ip_adde);//ĿĵַĴд뱾IPͬIPֵ
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_TCP);   //socketΪTCPģʽ
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);     //Socket	
	delay_ms(5);//ʱ5ms 	
	
	if(Read_W5500_SOCK_1Byte(s,Sn_SR) != SOCK_INIT)//socketʧ	 TCPģʽʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}

	Write_W5500_SOCK_1Byte(s,Sn_CR,CONNECT);//SocketΪConnectģʽ	TCPΪͻ					

	do
	{
		u8 j=0;
		j=Read_W5500_SOCK_1Byte(s,Sn_IR);//ȡSocket0жϱ־Ĵ
		if(j!=0)						 //жʾ д1Ӧж
		Write_W5500_SOCK_1Byte(s,Sn_IR,j);
		delay_ms(5);//ʱ5ms 
		if((j&IR_TIMEOUT) == IR_TIMEOUT) //ʱ
		{
			return FALSE;	
		}
		else if(Read_W5500_SOCK_1Byte(s,Sn_DHAR) != 0xff)	 //ֻжĩλMAC ǷΪFF ɹӦΪFF
		{
			Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//رSocket	   ˵Գɹ
			return TRUE;							
		}
	}while(1);
}




//ָSocket(0~7)ʼ
//s:ʼĶ˿
void Socket_Init(SOCKET s)
{
	//÷ƬȣοW5500ֲᣬֵԲ޸	
	Write_W5500_SOCK_2Byte(0, Sn_MSSR, 1460);//Ƭֽ=1460(0x5b4)

	Write_W5500_SOCK_2Byte(1, Sn_MSSR, 1460);//Ƭֽ=1460(0x5b4)
	//ָ˿
	switch(s)
	{
		case 0:
			//ö˿0Ķ˿ں
			Write_W5500_SOCK_2Byte(0, Sn_PORT, S0_Port[0]*256+S0_Port[1]);
			//ö˿0Ŀ(Զ)˿ں
			Write_W5500_SOCK_2Byte(0, Sn_DPORTR, S0_DPort[0]*256+S0_DPort[1]);
			//ö˿0Ŀ(Զ)IPַ
			Write_W5500_SOCK_4Byte(0, Sn_DIPR, S0_DIP);			
			
			break;

		case 1:
			//ö˿1Ķ˿ں
			Write_W5500_SOCK_2Byte(1, Sn_PORT, S0_Port[0]*256+S0_Port[1]);
			//ö˿1Ŀ(Զ)˿ں
			Write_W5500_SOCK_2Byte(1, Sn_DPORTR, S0_DPort[0]*256+S0_DPort[1]);
			//ö˿1Ŀ(Զ)IPַ
			Write_W5500_SOCK_4Byte(1, Sn_DIPR, S0_DIP);	


			break;

		case 2:
			break;

		case 3:
			break;

		case 4:
			break;

		case 5:
			break;

		case 6:
			break;

		case 7:
			break;

		default:
			break;
	}
}



//ָSocket(0~7)ΪͻԶ̷
//s:趨Ķ˿
//ֵ:ɹTRUE(0xFF),ʧܷFALSE(0x00)
//˵  :Socketڿͻģʽʱ,øó,Զ̷
//	     Ӻֳʱжϣʧ,Ҫµøó
//	     óÿһ,һ
u8 Socket_Connect(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_TCP);//socketΪTCPģʽ
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket
	delay_ms(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_INIT)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}
	Write_W5500_SOCK_1Byte(s,Sn_CR,CONNECT);//SocketΪConnectģʽ
	return TRUE;//TRUE,óɹ
}




//ָSocket(0~7)ΪȴԶ
//s:趨Ķ˿
//ֵ:ɹTRUE(0xFF),ʧܷFALSE(0x00)
//˵  :Socketڷģʽʱ,øó,ȵԶ
//		 óֻһ,ʹW5500Ϊģʽ
u8 Socket_Listen(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_TCP);//socketΪTCPģʽ 
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket	
	delay_ms(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_INIT)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}	
	Write_W5500_SOCK_1Byte(s,Sn_CR,LISTEN);//SocketΪģʽ	
	delay_ms(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_LISTEN)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//òɹ,رSocket
		return FALSE;//FALSE(0x00)
	}

	return TRUE;

	//SocketĴ򿪺,Զ̿ͻǷ,ҪȴSocketжϣ
	//жSocketǷɹοW5500ֲSocketж״̬
	//ڷģʽҪĿIPĿĶ˿ں
}





//ָSocket(0~7)ΪUDPģʽ
//s:趨Ķ˿
//ֵ:ɹTRUE(0xFF),ʧܷFALSE(0x00)
//˵  :SocketUDPģʽ,øó,UDPģʽ,SocketͨŲҪ
//		 óֻһΣʹW5500ΪUDPģʽ
u8 Socket_UDP(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_UDP);//SocketΪUDPģʽ*/
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket*/
	delay_ms(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_UDP)//Socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}
	else
		return TRUE;

	//SocketĴ򿪺UDPģʽ,ģʽҪԶ
	//ΪSocketҪ,ڷǰĿIPĿSocketĶ˿ں
	//ĿIPĿSocketĶ˿ںǹ̶,йûиı,ôҲ
}





//:W5500_Interrupt_Process
//  :W5500жϴ
void W5500_Interrupt_Process(void)
{
	u8 i,j;

IntDispose:
	W5500_Interrupt=0;//жϱ־
	i = Read_W5500_1Byte(IR);//ȡжϱ־Ĵ
	Write_W5500_1Byte(IR, (i&0xf0));//джϱ־

//	if((i & CONFLICT) == CONFLICT)//IPַͻ쳣
//	{
//		 //ԼӴ
//	}
//
//	if((i & UNREACH) == UNREACH)//UDPģʽµַ޷쳣
//	{
//		//ԼӴ
//	}

	i=Read_W5500_1Byte(SIR);//ȡ˿жϱ־Ĵ	
	if((i & S0_INT) == S0_INT)//Socket0¼ 
	{
		j=Read_W5500_SOCK_1Byte(0,Sn_IR); //ȡSocket0жϱ־Ĵ
		Write_W5500_SOCK_1Byte(0,Sn_IR,j);//джϱ־

		if(j&IR_CON)//TCPģʽ,Socket0ɹ 
		{
			S0_State|=S_CONN;//״̬0x02,˿ӣ
		}
		if(j&IR_DISCON)//TCPģʽSocketϿӴ
		{
			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//رն˿,ȴ´ 
			Socket_Init(0);		//ָSocket(0~7)ʼ,ʼ˿0
			S0_State=0;//״̬0x00,˿ʧ
		}
		if(j&IR_SEND_OK)//Socket0ݷ,ٴS_tx_process() 
		{
			S0_Data|=S_TRANSMITOK;//˿ڷһݰ 
		}
		if(j&IR_RECV)//Socketյ,S_rx_process() 
		{
			S0_Data|=S_RECEIVE;//˿ڽյһݰ
		}
		if(j&IR_TIMEOUT)//Socketӻݴ䳬ʱ 
		{
			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);// رն˿,ȴ´ 
			S0_State=0;//״̬0x00,˿ʧ
		}
	}

	if((i & S1_INT) == S1_INT)//Socket0¼ 
	{
		j=Read_W5500_SOCK_1Byte(1,Sn_IR); //ȡSocket0жϱ־Ĵ
		Write_W5500_SOCK_1Byte(1,Sn_IR,j);//джϱ־

		if(j&IR_CON)//TCPģʽ,Socket0ɹ 
		{
			S1_State|=S_CONN;//״̬0x02,˿ӣ
		}
		if(j&IR_DISCON)//TCPģʽSocketϿӴ
		{
			Write_W5500_SOCK_1Byte(1,Sn_CR,CLOSE);//رն˿,ȴ´ 
			Socket_Init(1);		//ָSocket(0~7)ʼ,ʼ˿0
			S1_State=0;//״̬0x00,˿ʧ
		}
		if(j&IR_SEND_OK)//Socket0ݷ,ٴS_tx_process() 
		{
			S1_Data|=S_TRANSMITOK;//˿ڷһݰ 
		}
		if(j&IR_RECV)//Socketյ,S_rx_process() 
		{
			S1_Data|=S_RECEIVE;//˿ڽյһݰ
		}
		if(j&IR_TIMEOUT)//Socketӻݴ䳬ʱ 
		{
			Write_W5500_SOCK_1Byte(1,Sn_CR,CLOSE);// رն˿,ȴ´ 
			S1_State=0;//״̬0x00,˿ʧ
		}
	}


	if(Read_W5500_1Byte(SIR) != 0) 
		goto IntDispose;
}

